/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 4.0.2
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */
package com.herumi.mcl

import kotlin.jvm.JvmOverloads
import com.herumi.mcl.MclJNI
import kotlin.jvm.Synchronized
import com.herumi.mcl.Fp
import com.herumi.mcl.Fr
import com.herumi.mcl.G1
import com.herumi.mcl.G2
import com.herumi.mcl.GT
import com.herumi.mcl.MclConstants
import com.herumi.mcl.SWIGTYPE_p_bool
import com.herumi.mcl.ElgamalJNI
import com.herumi.mcl.CipherText

object Mcl : MclConstants {
    fun SystemInit(curveType: Int) {
        MclJNI.SystemInit(curveType)
    }

    fun neg(y: Fr?, x: Fr?) {
        MclJNI.neg__SWIG_0(Fr.getCPtr(y), y, Fr.getCPtr(x), x)
    }

    fun inv(y: Fr?, x: Fr?) {
        MclJNI.inv__SWIG_0(Fr.getCPtr(y), y, Fr.getCPtr(x), x)
    }

    fun add(z: Fr?, x: Fr?, y: Fr?) {
        MclJNI.add__SWIG_0(
            Fr.getCPtr(z),
            z,
            Fr.getCPtr(x),
            x,
            Fr.getCPtr(y),
            y
        )
    }

    fun sub(z: Fr?, x: Fr?, y: Fr?) {
        MclJNI.sub__SWIG_0(
            Fr.getCPtr(z),
            z,
            Fr.getCPtr(x),
            x,
            Fr.getCPtr(y),
            y
        )
    }

    fun mul(z: Fr?, x: Fr?, y: Fr?) {
        MclJNI.mul__SWIG_0(
            Fr.getCPtr(z),
            z,
            Fr.getCPtr(x),
            x,
            Fr.getCPtr(y),
            y
        )
    }

    fun mul(z: G1?, x: G1?, y: Fr?) {
        MclJNI.mul__SWIG_1(
            G1.getCPtr(z),
            z,
            G1.getCPtr(x),
            x,
            Fr.getCPtr(y),
            y
        )
    }

    fun mul(z: G2?, x: G2?, y: Fr?) {
        MclJNI.mul__SWIG_2(
            G2.getCPtr(z),
            z,
            G2.getCPtr(x),
            x,
            Fr.getCPtr(y),
            y
        )
    }

    fun div(z: Fr?, x: Fr?, y: Fr?) {
        MclJNI.div__SWIG_0(
            Fr.getCPtr(z),
            z,
            Fr.getCPtr(x),
            x,
            Fr.getCPtr(y),
            y
        )
    }

    fun pow(z: GT?, x: GT?, y: Fr?) {
        MclJNI.pow(
            GT.getCPtr(z),
            z,
            GT.getCPtr(x),
            x,
            Fr.getCPtr(y),
            y
        )
    }

    fun neg(y: Fp?, x: Fp?) {
        MclJNI.neg__SWIG_1(Fp.getCPtr(y), y, Fp.getCPtr(x), x)
    }

    fun inv(y: Fp?, x: Fp?) {
        MclJNI.inv__SWIG_1(Fp.getCPtr(y), y, Fp.getCPtr(x), x)
    }

    fun add(z: Fp?, x: Fp?, y: Fp?) {
        MclJNI.add__SWIG_1(
            Fp.getCPtr(z),
            z,
            Fp.getCPtr(x),
            x,
            Fp.getCPtr(y),
            y
        )
    }

    fun sub(z: Fp?, x: Fp?, y: Fp?) {
        MclJNI.sub__SWIG_1(
            Fp.getCPtr(z),
            z,
            Fp.getCPtr(x),
            x,
            Fp.getCPtr(y),
            y
        )
    }

    fun mul(z: Fp?, x: Fp?, y: Fp?) {
        MclJNI.mul__SWIG_3(
            Fp.getCPtr(z),
            z,
            Fp.getCPtr(x),
            x,
            Fp.getCPtr(y),
            y
        )
    }

    fun div(z: Fp?, x: Fp?, y: Fp?) {
        MclJNI.div__SWIG_1(
            Fp.getCPtr(z),
            z,
            Fp.getCPtr(x),
            x,
            Fp.getCPtr(y),
            y
        )
    }

    fun neg(y: G1?, x: G1?) {
        MclJNI.neg__SWIG_2(G1.getCPtr(y), y, G1.getCPtr(x), x)
    }

    fun dbl(y: G1?, x: G1?) {
        MclJNI.dbl__SWIG_0(G1.getCPtr(y), y, G1.getCPtr(x), x)
    }

    fun add(z: G1?, x: G1?, y: G1?) {
        MclJNI.add__SWIG_2(
            G1.getCPtr(z),
            z,
            G1.getCPtr(x),
            x,
            G1.getCPtr(y),
            y
        )
    }

    fun sub(z: G1?, x: G1?, y: G1?) {
        MclJNI.sub__SWIG_2(
            G1.getCPtr(z),
            z,
            G1.getCPtr(x),
            x,
            G1.getCPtr(y),
            y
        )
    }

    fun pairing(e: GT?, P: G1?, Q: G2?) {
        MclJNI.pairing(
            GT.getCPtr(e),
            e,
            G1.getCPtr(P),
            P,
            G2.getCPtr(Q),
            Q
        )
    }

    fun hashAndMapToG1(P: G1?, cbuf: ByteArray?) {
        MclJNI.hashAndMapToG1(G1.getCPtr(P), P, cbuf)
    }

    fun neg(y: G2?, x: G2?) {
        MclJNI.neg__SWIG_3(G2.getCPtr(y), y, G2.getCPtr(x), x)
    }

    fun dbl(y: G2?, x: G2?) {
        MclJNI.dbl__SWIG_1(G2.getCPtr(y), y, G2.getCPtr(x), x)
    }

    fun add(z: G2?, x: G2?, y: G2?) {
        MclJNI.add__SWIG_3(
            G2.getCPtr(z),
            z,
            G2.getCPtr(x),
            x,
            G2.getCPtr(y),
            y
        )
    }

    fun sub(z: G2?, x: G2?, y: G2?) {
        MclJNI.sub__SWIG_3(
            G2.getCPtr(z),
            z,
            G2.getCPtr(x),
            x,
            G2.getCPtr(y),
            y
        )
    }

    fun hashAndMapToG2(P: G2?, cbuf: ByteArray?) {
        MclJNI.hashAndMapToG2(G2.getCPtr(P), P, cbuf)
    }

    fun mul(z: GT?, x: GT?, y: GT?) {
        MclJNI.mul__SWIG_4(
            GT.getCPtr(z),
            z,
            GT.getCPtr(x),
            x,
            GT.getCPtr(y),
            y
        )
    }

    fun inv(y: GT?, x: GT?) {
        MclJNI.inv__SWIG_2(GT.getCPtr(y), y, GT.getCPtr(x), x)
    }

    fun verifyOrderG1(doVerify: Boolean) {
        MclJNI.verifyOrderG1(doVerify)
    }

    fun verifyOrderG2(doVerify: Boolean) {
        MclJNI.verifyOrderG2(doVerify)
    }
}